# -*- coding: utf8 -*-
# 네임스페이스를 나눠서 사용하면 안됨! from Request import * 이럼 안됨!
import os
import cgi

import utils
import config

class Singleton(object): 
	def __new__(klass, *args, **kws):
		instance = klass.__dict__.get("__instance__") 
		if instance is not None: 
			return instance
		klass.__instance__ = instance = object.__new__(klass) 
		return instance


class Request(Singleton):
	def __init__(self):
		if 'isFirst' not in self.__dict__.keys():
			self.init()
	def init(self):
		self.env = os.environ
		self.form = cgi.FieldStorage()
			
		self.action = self.form.getvalue('action', 'view')
		self.scriptName =  self.env.get('SCRIPT_NAME', '')
		pathInfo = self.env.get('PATH_INFO', '')
		self.remoteAddr = self.env.get('REMOTE_ADDR', '0.0.0.0')
		pathInfo = self._toMyCharset(pathInfo)
		while pathInfo and pathInfo[-1] == '/':
			pathInfo = pathInfo[:-1]
		splitedPath = pathInfo.split('/')
		self.pageName = splitedPath[-1] or 'FrontPage' 
		self.categoryPath = '/'.join(splitedPath[1:-1])
		self.setActionPath(self.categoryPath, self.pageName)
		self.isFirst = True

	def _toMyCharset(self, text, charset=config.charset): 
		try:
			text = text.decode('UTF-8').encode(charset)
		except UnicodeError:
			pass
		return text
	def setActionPath(self, categoryPath, pageName):
		self.actionPath = self.scriptName + '/' + utils.joinPath(categoryPath, pageName) 
	def __getattr__(self, key):
		if key in self.__dict__.keys():
			return self.__dict__.get(key)
		return self.form.getvalue(key, '')
