# -*- coding: utf8 -*-
import os
import sha

import utils
import Repository
from WikiException import WikiException
class NotExistUser(WikiException): pass
class InvalidUserData(WikiException): pass

class User:
	fieldList = ['uType', 'passwd', 'email']
	def __init__(self, uid): 
		self.uid = uid
		if self.uid.lower() != 'anonymous':
			self.userFilePath = os.path.join(Repository.getUserRepository(), utils.encode(self.uid))
			if not os.path.exists(self.userFilePath):
				raise NotExistUser
			infoList = file(self.userFilePath, 'rb').read().split()
			if len(self.fieldList) != len(infoList):
				raise InvalidUserData
			for i in range(len(self.fieldList)):
				self.__dict__[self.fieldList[i]] = infoList[i]
		else:
			self.passwd = ''
			self.email = ''
			self.uType = 'anony'

	def update(self, passwd, email):
		if passwd:
			self.passwd = sha.new(passwd).hexdigest()
		self.email = email
		file(self.userFilePath, 'wb').write('\n'.join([self.uType, self.passwd, self.email]))
