# -*- coding: utf8 -*-

import urllib
import cgi

import Request
import Category

def encode(pageName):
	return urllib.quote(pageName).replace('%', '_')

def decode(encPageName):
	return urllib.unquote(encPageName.replace('_', '%'))

escape = cgi.escape
quote = urllib.quote

def nl2br(text):
	return text.replace('\n', '<br />')

def joinPath(*args):
	args = filter(None, args)
	return '/'.join(args)

def makeLink(categoryPath, pageName='', klass='', linkName=''):
	request = Request.Request()
	pagePath = joinPath(categoryPath, pageName)
	linkPath = request.scriptName +'/'+ joinPath(categoryPath, pageName)
	klass = klass and ' class="%s"' % klass or '' 
	return '<a%s href="%s" title="%s">%s</a>' % (klass, linkPath, pagePath, linkName or pagePath)

def makeStairLink(categoryPath):
	nameList = filter(None, categoryPath.split(Category.sep))
	L = []
	for index in range(len(nameList)):
		L.append(makeLink(Category.sep.join(nameList[:index+1]), linkName=nameList[index]))
	return ' > '.join(L)

def isValidName(name, minLength=1, maxLength=40, whitespaceCheck=False):
	if len(name) > maxLength or len(name) < minLength:
		return False
	if whitespaceCheck:
		if ' ' in name or '\t' in name:
			return False
	invalidChars = '!"#$%&\'()*+,-./:;<=>?@[\\]^_`{|}~'
	#!?+-_는 허용할까?
	for c in name:
		if c in invalidChars:
			return False
	return True


